﻿using System.Windows;

using TestProject.NorthwindDataSetTableAdapters;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 제품 데이터 테이블
        /// </summary>
        private NorthwindDataSet.ProductsDataTable productsDataTable;

        /// <summary>
        /// 현재 레코드
        /// </summary>
        private int currentRecord;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.productsDataTable = new ProductsTableAdapter().GetData();

            this.currentRecord = 0;

            DataContext = this.productsDataTable[currentRecord];

            this.comboBoxEdit.ItemsSource = new CategoriesTableAdapter().GetData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Previous 버튼 클릭시 처리하기 - previousButton_Click(sender, e)

        /// <summary>
        /// Previous 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void previousButton_Click(object sender, RoutedEventArgs e)
        {
            this.currentRecord--;

            UpdateData();

            UpdateButtonState();
        }

        #endregion
        #region Next 버튼 클릭시 처리하기 - nextButton_Click(sender, e)

        /// <summary>
        /// Next 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void nextButton_Click(object sender, RoutedEventArgs e)
        {
            this.currentRecord++;

            UpdateData();

            UpdateButtonState();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 데이터 갱신하기 - UpdateData()

        /// <summary>
        /// 데이터 갱신하기
        /// </summary>
        private void UpdateData()
        {
            DataContext = this.productsDataTable[currentRecord];
        }

        #endregion
        #region 버튼 상태 갱신하기 - UpdateButtonState()

        /// <summary>
        /// 버튼 상태 갱신하기
        /// </summary>
        private void UpdateButtonState()
        {
            this.previousButton.IsEnabled = this.currentRecord != 0;
            this.nextButton.IsEnabled     = this.currentRecord != this.productsDataTable.Rows.Count - 1;
        }

        #endregion
    }
}